unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, winsock, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Label4: TLabel;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    private
    function IpToMAC(ip:string):string;
  end;

function SendARP(DestIP:DWORD;SrcIP:DWORD; var pMacAddr; var PhyAddrLen:DWORD):DWORD;stdcall;external 'IPHLPAPI.DLL';

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure GetManufacturer(MAC:string);
var
 T:text;
 s,IDfromMAC, IDfromFile, name:string;
begin
 Assignfile(T,'Names.txt');
 Reset(T);
 IDfromMAC:=MAC[11]+MAC[12]+MAC[9]+MAC[10]+MAC[7]+MAC[8];
repeat
 Readln(T, S);
 if length(s)>7 then begin
   IDfromFile:=copy(s,1,6);
   if IDfromFile=IDfromMAC then begin
     name:=copy(s,8,length(s)-6);
     form1.Edit4.Text:=name;
     Break;
   end;
 end;
until eof(T);
 CloseFile(T);
end;

function TForm1.IpToMAC(ip:string):string;
var
 n,ipadr,res:cardinal;
 r:array [0..1] of cardinal;
 x:string;
begin 
r[0]:=0;
r[1]:=0;
n:=6;
ipadr:=inet_addr(pchar(ip));
res:=sendarp(ipadr,0,r,n);     //no_error = 0
if res=no_error then
 begin
  x:=format('%x',[r[1]])+format('%x',[r[0]]);
  GetManufacturer(x);
  for n:=6 downto 1 do result:=result+x[n*2-1]+x[n*2]+'-';
  delete(result,length(result),1);
 end else result:='Unknown';
end;

function HostToIP(Name: string; var Ip: string): Boolean; 
var
 wsdata : TWSAData;
 hostName : array [0..255] of char;
 hostEnt : PHostEnt;
 addr : PChar; 
begin
 WSAStartup ($0101, wsdata);
 try
  gethostname (hostName, sizeof (hostName));
  StrPCopy(hostName, Name);
  hostEnt := gethostbyname (hostName);
  if Assigned (hostEnt) then
    if Assigned (hostEnt^.h_addr_list) then begin
      addr := hostEnt^.h_addr_list^;
      if addr<>nil then begin
        IP := Format ('%d.%d.%d.%d', [byte (addr [0]),byte (addr [1]), byte (addr [2]), byte (addr [3])]);
        Result := True;
      end else Result := False;
    end else Result := False
  else Result := False;
 finally
  WSACleanup;
 end
end;

function IPToHost(IPAddr : String): String;
var
 SockAddrIn: TSockAddrIn;
 HostEnt: PHostEnt;
 WSAData: TWSAData;
begin
 WSAStartup($101, WSAData);
 SockAddrIn.sin_addr.s_addr:= inet_addr(PChar(IPAddr));
 HostEnt:= gethostbyaddr(@SockAddrIn.sin_addr.S_addr, 4, AF_INET);
 if HostEnt<>nil then
  begin
   result:=string(Hostent^.h_name);
  end
 else result:='';
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
 var r:string;
begin
if key=#13 then
 begin
  HostToIp(Edit1.Text, r);
  edit2.text:=r;
  edit3.Text:=IpToMAC(r);
 end;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then begin
  edit1.text:= IPToHost(edit2.text);
  edit3.Text:=IpToMAC(edit2.Text);
 end;
end;

end.
